/* 
* VMMLib - Vector & Matrix Math Lib
*  
* @author Jonas Boesch
* @author Stefan Eilemann
* @author Renato Pajarola
* @author David H. Eberly ( Wild Magic )
* @author Andrew Willmott ( VL )
*
* @license revised BSD license, check LICENSE
*
* parts of the source code of VMMLib were inspired by David Eberly's 
* Wild Magic and Andrew Willmott's VL.
* 
*/ 


#ifndef __VMML__VMMLIB__H__
#define __VMML__VMMLIB__H__

#include <vmmlib/vector2.h>
#include <vmmlib/vector3.h>
#include <vmmlib/vector4.h>
#include <vmmlib/matrix3.h>
#include <vmmlib/matrix4.h>
#include <vmmlib/quaternion.h>
#include <vmmlib/frustum.h>
#include <vmmlib/frustumCuller.h>

#endif
